
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在ASP.NET 2.0中操作数据之二十五：大数据量时提高分页的效率_自学过程 / iVAN</title>

    <meta name="description" content="在ASP.NET 2.0中操作数据之二十五：大数据量时提高分页的效率_自学过程 导言 如我们在之前的教程里讨论的那样,分页可以通过两种方法来实现: 1.默认分页– 你仅仅只用选中data Web control的 智能标签的Enable Paging ; 然而,当你浏览页面的时候,虽然你看到的只是一小部分数据,ObjectDataSource 还是会每次都读取所有数据 2.自定义分页– 通过只从数据库读取用户需要浏览的那部分数据,提高了性能. 显然这种方法需要你做更多的工作. 默认的分页功能非常吸引人,因为你只需要选中一个checkbox就可以完成了.但是它每次都读取所有的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">在ASP.NET 2.0中操作数据之二十五：大数据量时提高分页的效率_自学过程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>导言</strong></p>
<p>　　如我们在之前的教程里讨论的那样,分页可以通过两种方法来实现:</p>
<p>　　１.默认分页– 你仅仅只用选中data Web control的 智能标签的Enable Paging ; 然而,当你浏览页面的时候,虽然你看到的只是一小部分数据,ObjectDataSource 还是会每次都读取所有数据</p>
<p>　　２.自定义分页– 通过只从数据库读取用户需要浏览的那部分数据,提高了性能. 显然这种方法需要你做更多的工作.</p>
<p>　　默认的分页功能非常吸引人,因为你只需要选中一个checkbox就可以完成了.但是它每次都读取所有的数据,这种方式在大数据量或者并发用户多的情况下就不合适.在这样的情况下,我们必须通过自定义分页来使系统达到更好的性能.</p>
<p>　　自定义分页的一个重点是要写一个返回仅仅需要的数据的查询语句.幸运的,Microsoft SQL Server 2005 提供了一个新的keyword,通过它我们可以写出读取需要的数据的查询.在本教程里,我们将学习在GridView里如何使用Microsoft SQL Server 2005 的这个新的keyword来实现自定义分页.自定义分页和默认分页的界面看起来一样,但是当你从一页转到另一页时,在效率上差了几个数量级.</p>
<p>注意:自定义分页带来的性能提升程序取决于数据的总量和数据库的负载.在本教程的最后我们会用数据来说明自定义分页带来的性能方面的好处.</p>
<p><strong>第一步: 理解自定义分页的过程</strong></p>
<p>　　给数据分页的时候,页面显示的数据取决于请求的是哪一页和每页显示多少条.比如,想象以下我们给81个product分页,每页显示10条.当我们浏览第一页时,我们需要的是product 1 到 product 10.当浏览第二页时,我们需要的是product 11 到 product 20,以次类推.</p>
<p>　　对于需要读取什么数据和分页的页面怎么显示,有三个相关的变量:</p>
<p>　　１.Start Row Index – 页面里显示数据的第一行的索引; 这个值可以通过页的索引乘每页显示的记录的条数加1得到. 例如, 如果一页显示10条数据, 那么对第一页来说(第一页的索引为0), 第一行的索引为0 * 10 + 1, or 1; 对第二页来说(索引为1), 第一行的索引为1 * 10 + 1, 即 11.</p>
<p>　　２.Maximum Rows – 每页显示的最多记录的条数. 之所以称为“maximum” rows 是由于最后一页显示的数据可能会比page size要小. 比如, 当以每页10条记录来显示81条时, 最后一页也就是第九页只包含一条记录. 没有页面显示的记录条数会大于Maximum Rows 的值.</p>
<p>　　３.Total Record Count – 显示数据的总条数. 不需要知道页面显示什么数据,但是记录总数会影响到分页. 比如, 如果对81条product记录分页,每页10条,那么总页数为9.</p>
<p>　　对默认分页来说,Start Row Index是由页索引和每页的记录数加1得到,Maximum Rows 就是每页的记录数.使用默认分页时,不管是呈现哪页的数据,都是要读取全部的数据,所有每行的索引都是已知的,这样获取Start Row Index变的没有价值.而且,记录的总条数是可以通过DataTable的总条数来获取的.</p>
<p>　　自定义分页只返回从Start Row Index 开始的Maximum Rows条记录.在这里有两个要注意的地方:</p>
<p>　　１.我们必须把整个要分页的数据和一个row index关联起来,这样才能从指定的Start Row Index 开始返回需要的数据.</p>
<p>　　２.我们需要提供用来分页的数据的总条数.</p>
<p>　　在后面的两步里我们将写出和上面两点相关的SQL.除此之外，我们还将在DAL和BLL里完成相应的方法.</p>
<p><strong>第二步: 返回需要分页的记录的总条数</strong></p>
<p>　　在我们学习如何返回显示页面需要的数据之前,我们先来看看怎么获取数据的总条数.因为在配置界面的时候需要用到这个信息.我们使用SQL的COUNT aggregate function来实现这个.比如,返回Products表的总记录条数,我们可以用如下的语句:</p>
<pre>
SELECT COUNT(*)
FROM Products</pre>
<p>我们在DAL里添加一个方法来返回这个信息.这个方法名为TotalNumberOfProducts() ,它会执行上面的SQL语句.</p>
<p>　　打开App_Code/DAL 文件夹里的 Northwind.xsd .然后在设计器里右键点ProductsTableAdapter ,选择Add Query.和我们在以前的教程里学习的那样,这样会允许我们添加一个新的DAL方法,这个方法被调用时会执行指定的SQL或存储过程.和前面的TableAdapter 方法一样,为这个添加一个SQL statement.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzMzNzE1NS5wbmc=.jpg"></p>
<p><strong>图 1: 使用 SQL Statement</strong></p>
<p>在下一个窗体我们可以指定创建哪种SQL .由于查询只返回一个值–Products表的总记录条数–我们选择“SELECT which returns a singe value”.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0MTE1Ni5wbmc=.jpg"></p>
<p><strong>图 2: 使用 SELECT Statement that Returns a Single Value来配置SQL</strong></p>
<p>下一步是写SQL语句.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0MTE1Ny5wbmc=.jpg"></p>
<p><strong>图 3: 使用SELECT COUNT(*) FROM Products 语句</strong></p>
<p>最后给这个方法命名为TotalNumberOfProducts.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0NDE1OC5wbmc=.jpg"></p>
<p><strong>图 4: 将方法命名为 TotalNumberOfProducts</strong></p>
<p>　　点击结束后,DAL里添加了一个TotalNumberOfProducts方法.这个方法返回的值可为空,而Count语句总是返回一个非空的值.<br />
我们还需要在BLL中加一个方法.打开ProductsBLL类文件,添加一个TotalNumberOfProducts方法,这个方法要做的只是调用DAL的TotalNumberOfProducts方法.</p>
<pre>
public int TotalNumberOfProducts()
{
 return Adapter.TotalNumberOfProducts().GetValueOrDefault();
}
</pre>
<p>　　DAL的TotalNumberOfProducts方法返回一个可空的整型,而需要ProductsBLL类的TotalNumberOfProducts方法返回一个标准的整型.调用GetValueOrDefault方法,如果可为空的整型为空,则返回默认值,0.</p>
<p><strong>第三步: 返回需要的数据记录</strong></p>
<p>　　下一步我们要在DAL和BLL里创建接受Start Row Index 和Maximum Rows 的方法,然后返回合适的记录.我们首先看看需要的SQL语句.我们面临的挑战是需要为整个分页的记录分配索引,用来返回从Start Row Index 开始的Maximum Records number of records条记录.</p>
<p>　　如果在数据库表里已经有一个列作为索引,那么一切会变的很简单.我们首先会想到Products表的ProductID字段可以满足这个条件,第一个Product的ProductID为1,第二个为2,以此类推.然而当一个product被删除后,这个序列会留下间隔来,所以这个方法不行.</p>
<p>　　有两种可以把整个要分页的数据和一个row index关联起来的方法.</p>
<p>　　１.使用SQL Server 2005的ROW_NUMBER() Keyword – SQL Server 2005的新特性,它可以将记录根据一定的顺序排列,每条记录和一个等级相关 这个等级可以用来作为每条记录的row index.</p>
<p>　　２.使用SET ROWCOUNT – SQL Server的 SET ROWCOUNT statement 可以用来指定有多少记录需要处理; table variables 是可以存放表格式的T-SQL 变量, 和temporary tables类似. 这个方法在Microsoft SQL Server 2005 和SQL Server 2000都可以用 (ROW_NUMBER() 方法只能在SQL Server 2005里用).</p>
<p>　　这个思路是,为要分页的数据创建一个table变量,这个table变量里有一个作为主健的IDENTITY列.这样需要分页的每条记录在table变量里就和一个row index(通过IDENTITY列)关联起来了.一旦table变量产生,连接数据库表的SELECT语句就被执行,获取需要的记录.SET ROWCOUNT用来限制放到table变量里的记录的数量.</p>
<p>　　当SET ROWCOUNT的值指定为Start Row Index 加上Maximum Rows时,这个方法的效率取决于被请求的页数.对于比较前面的页来说– 比如开始几页的数据– 这种方法非常有效. 但是对接近尾部的页来说,这种方法的效率和默认分页时差不多.</p>
<p>　　本教程用ROW_NUMBER()来实现自定义分页.如果需要知道更多的关于table变量和SET ROWCOUNT的技术,请看 A More Efficient Method for Paging Through Large Result Sets.</p>
<p>以下语句用来使用ROW_NUMBER()将一个等级和返回的每条记录关联:</p>
<pre>
SELECT columnList,
 ROW_NUMBER() OVER(orderByClause)
FROM TableName</pre>
<p>ROW_NUMBER()返回一个根据指定排序的表示每条记录的等级的值.比如,我们可以用以下居于查看根据价格来排序(降序)的每个product的等级:</p>
<pre>
SELECT ProductName, UnitPrice,
 ROW_NUMBER() OVER(ORDER BY UnitPrice DESC) AS PriceRank
FROM Products
</pre>
<p>图5 是在Visual Studio里运行以上代码的结果. 注意product根据价格排序,每行有一个等级.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0NzE1OS5wbmc=.jpg"></p>
<p><strong>图 5: 返回的记录里每行有一个Price Rank</strong></p>
<p>　　注意: ROW_NUMBER() 只是 SQL Server 2005里很多排级的功能中的一种. 想了解更多的ROW_NUMBER()的讨论,包括其它的排级功能,请看 Returning Ranked Results with Microsoft SQL Server 2005.</p>
<p>　　当使用OVER从句里的ORDER BY 列名(UnitPrice)来排级时,SQL Server会对结果排序.为了提升大数据量查询时的性能,可以为用来排序的列加上非聚集索引.更多的性能考虑参考Ranking Functions and Performance in SQL Server 2005.</p>
<p>　　ROW_NUMBER()返回的等级信息无法直接在WHERE从句中使用.而在From后面的Select里可以返回ROW_NUMBER(),并在WHERE从句里使用.比如,下面的语句使用一个From后的Select返回ProductName,UnitPrice,和ROW_NUMBER()的结果,然后使用一个WHERE从句来返回price rank在11到20之间的product.</p>
<pre>
SELECT PriceRank, ProductName, UnitPrice
FROM
 (SELECT ProductName, UnitPrice,
 ROW_NUMBER() OVER(ORDER BY UnitPrice DESC) AS PriceRank
 FROM Products
 ) AS ProductsWithRowNumber
WHERE PriceRank BETWEEN 11 AND 20
</pre>
<p>更进一步,我们可以根据这个方法返回给定Start Row Index 和Maximum Rows 的页的数据.</p>
<pre>
SELECT PriceRank, ProductName, UnitPrice
FROM
 (SELECT ProductName, UnitPrice,
 ROW_NUMBER() OVER(ORDER BY UnitPrice DESC) AS PriceRank
 FROM Products
 ) AS ProductsWithRowNumber
WHERE PriceRank &gt; &lt;i&gt;StartRowIndex&lt;/i&gt; AND
 PriceRank &lt;= (&lt;i&gt;StartRowIndex&lt;/i&gt; + &lt;i&gt;MaximumRows&lt;/i&gt;)
</pre>
<p>　　注意:我们在本教程的后面会看到, ObjectDataSource 提供的StartRowIndex是从0开始的,而ROW_NUMBER()的值从1开始.因此,WHERE从句返回会严格返回PriceRank大于StartRowIndex而小于StartRowIndex+MaximumRows的那些记录.</p>
<p>　　我们已经知道如何根据给定的Start Row Index 和Maximum Rows 用ROW_NUMBER()返回特定页的数据.现在我们需要在DAL和BLL里实现它.</p>
<p>　　我们首先要决定根据什么排序来分级.我们这里用product名字的字母顺序.这意味着我们还不能同时实现排序的功能.在后面的教程里,我们将学习如何实现这样的功能.</p>
<p>　　在前面我们使用SQL statement创建DAL方法.但是TableAdapter  wizard 使用的Visual Stuido里的T-SQL 解析器不能识别带OVER语法的ROW_NUMBER()方法.因此我们要以存储过程来创建这个DAL方法.从view menu里选择server explorer(Ctrl+Alt+S),展开NORTHWND.MDF 的节点.右键点击存储过程,选择增加一个新的存储过程(见图6).</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0ODE2MC5wbmc=.jpg"></p>
<p><strong>图 6: 为Products分页增加一个存储过程</strong></p>
<p>　　这个存储过程带两个整型的输入参数- @startRowIndex和@maximumRows- 并用ROW_NUMBER()以ProductName字段排序,返回那些大于@startRowIndex并小于等于@startRowIndex+@maximumRows的记录.将以下代码加到存储过程里,然后保存.</p>
<pre>
CREATE PROCEDURE dbo.GetProductsPaged
(
 @startRowIndex int,
 @maximumRows int
)
AS
 SELECT ProductID, ProductName, SupplierID, CategoryID, QuantityPerUnit,
 UnitPrice, UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued,
 CategoryName, SupplierName
FROM
 (
 SELECT ProductID, ProductName, SupplierID, CategoryID, QuantityPerUnit,
 UnitPrice, UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued,
 (SELECT CategoryName
 FROM Categories
 WHERE Categories.CategoryID = Products.CategoryID) AS CategoryName,
 (SELECT CompanyName
 FROM Suppliers
 WHERE Suppliers.SupplierID = Products.SupplierID) AS SupplierName,
 ROW_NUMBER() OVER (ORDER BY ProductName) AS RowRank
 FROM Products
 ) AS ProductsWithRowNumbers
WHERE RowRank &gt; @startRowIndex AND RowRank &lt;= (@startRowIndex + @maximumRows)
</pre>
<p>创建完存储过程后,花点时间测试一下.右键在Server Explorer 点名为GetProductsPaged的存储过程,选择执行.Visual Studio 会让你输入参数, @startRowIndex和@maximumRows(见图7).输入不同的值查看一下结果是什么.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0ODE2MS5wbmc=.jpg"></p>
<p><strong>图 7: 为 @startRowIndex 和@maximumRows Parameters输入值</strong></p>
<p>　　输入参数的值后,你会看到结果.图8的结果为两个参数的值都为10的结果.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM0ODE2Mi5wbmc=.jpg"></p>
<p><strong>图 8: 将在第二页里显示的数据</strong></p>
<p>　　完成存储过程后,我们可以创建ProductsTableAdapter 方法了.打开Northwind.xsd ,右键点ProductsTableAdapter,选择Add Query.选择使用已经存在的存储过程.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1MTE2My5wbmc=.jpg"></p>
<p><strong>图 9: 使用已经存在的存储过程创建DAL Method</strong></p>
<p>　　下一步会要我们选择要调用的存储过程.从下拉列表里选择GetProductsPaged .</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1MTE2NC5wbmc=.jpg"></p>
<p><strong>图10: 选择GetProductsPaged</strong></p>
<p>　　下一步要选择存储过程返回的数据类型:表值,单一值,无值.由于GetProductsPaged 返回多条记录,所以选择表值.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1MjE2NS5wbmc=.jpg"></p>
<p><strong>图 11: 为存储过程指定返回表值</strong></p>
<p>　　最后给方法命名.象前面的方法一样,选择Fill a DataTable 和Return a DataTable,为第一个命名为FillPaged ,第二个为GetProductsPaged.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1MjE2Ni5wbmc=.jpg"></p>
<p><strong>图 12: 命名方法为FillPaged 和GetProductsPaged</strong></p>
<p>　　除了创建一个DAL方法返回特定页的products外,我们需要在BLL里也这样做.和DAL方法一样,BLL的GetProductsPaged 方法带两个整型的输入参数,分别为Start Row Index 和Maximum Rows,并返回在指定范围内的记录.在ProductsBLL 创建这个方法,仅仅调用DAL的GetProductsPaged 就可以了.</p>
<pre>
[System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
public Northwind.ProductsDataTable GetProductsPaged(int startRowIndex, int maximumRows)
{
 return Adapter.GetProductsPaged(startRowIndex, maximumRows);
}</pre>
<p>　　你可以为BLL方法的参数取任何名字.但是我们马上会看到,选择用startRowIndex 和maximumRows 会让我们在配置ObjectDataSource 时方便很多.<br />
第四步: 使用自定义分页配置ObjectDataSource</p>
<p>　　创建完BLL和DAL的方法后,我们可以准备创建一个GridView 来使用自定义分页了.打开PagingAndSorting 文件夹里的EfficientPaging.aspx ,添加一个GridView ,然后用ObjectDataSource 来配置它.在我们以前的教程里,我们通常使用ProductsBLL 类的GetProducts 方法来配置ObjectDataSource .然而这一次,我们使用GetProductsPaged 方法.GetProducts 会返回所有的products而GetProductsPaged 只返回特定的记录.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1MjE2Ny5wbmc=.jpg"></p>
<p><strong>图 13: 使用ProductsBLL Class类的 GetProductsPaged方法 来配置ObjectDataSource</strong></p>
<p>　　我们要创建一个只读的GridView,因此在INSERT, UPDATE, 和DELETE 标签下拉列表里选择(None).</p>
<p>　　接下来ObjectDataSource 向导会让我们选择GetProductsPaged 方法的输入参数startRowIndex 和maximumRows 的值.在source里选择none.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1NTE2OC5wbmc=.jpg"></p>
<p><strong>图 14: Sources 里选择None</strong></p>
<p>　　完成ObjectDataSource 向导后,GridView 会为每个product字段创建一个BoundField 或CheckBoxField .可以随意裁减GridView 的外观.我这里选择的是只显示ProductName, CategoryName, SupplierName, QuantityPerUnit, 和UnitPrice BoundFields.在智能标签里选择支持分页,GridView 和ObjectDataSource 的标记看起来应该和下面差不多:</p>
<pre>
&lt;asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False"
 DataKeyNames="ProductID" DataSourceID="ObjectDataSource1" AllowPaging="True"&gt;
 &lt;Columns&gt;
 &lt;asp:BoundField DataField="ProductName" HeaderText="Product"
 SortExpression="ProductName" /&gt;
 &lt;asp:BoundField DataField="CategoryName" HeaderText="Category"
 ReadOnly="True" SortExpression="CategoryName" /&gt;
 &lt;asp:BoundField DataField="SupplierName" HeaderText="Supplier"
 SortExpression="SupplierName" /&gt;
 &lt;asp:BoundField DataField="QuantityPerUnit" HeaderText="Qty/Unit"
 SortExpression="QuantityPerUnit" /&gt;
 &lt;asp:BoundField DataField="UnitPrice" DataFormatString="{0:c}"
 HeaderText="Price" HtmlEncode="False" SortExpression="UnitPrice" /&gt;
 &lt;/Columns&gt;
&lt;/asp:GridView&gt;
&lt;asp:ObjectDataSource ID="ObjectDataSource1" runat="server"
 OldValuesParameterFormatString="original_{0}" SelectMethod="GetProductsPaged"
 TypeName="ProductsBLL"&gt;
 &lt;SelectParameters&gt;
 &lt;asp:Parameter Name="startRowIndex" Type="Int32" /&gt;
 &lt;asp:Parameter Name="maximumRows" Type="Int32" /&gt;
 &lt;/SelectParameters&gt;
&lt;/asp:ObjectDataSource&gt;
</pre>
<p>如果你通过浏览器浏览页面,你会发现看不到GridView .</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1NjE2OS5wbmc=.jpg"></p>
<p><strong>图 15: GridView 没有被显示</strong></p>
<p>　　由于在ObjectDataSource 里的GetProductsPaged的startRowIndex和maximumRows的参数都为0,由SQL没有返回任何的记录因此GridView 看不到了.</p>
<p>我们需要将ObjectDataSource 配置成为自定义分页来修补上面的问题.下面的步骤可以完成这个:</p>
<p>　　１.将ObjectDataSource的 EnablePaging 属性设为true – 这样表示必须传两个参数给SelectMethod方法: 一个指定Start Row Index (StartRowIndexParameterName), 一个指定Maximum Rows (MaximumRowsParameterName).</p>
<p>　　２.设置 ObjectDataSource的 StartRowIndexParameterName 和MaximumRowsParameterName 属性– StartRowIndexParameterName 和MaximumRowsParameterName 属性是传给SelecMethod用来自定义分页的输入参数. 默认的参数名为startIndexRow and MaximumRows, 这就是在创建BLL里的GetProductsPaged方法时用这些给参数命名的原因 . 如果你使用了其它的参数名字–比如startIndex和maxRows–你将不得不相应的设置ObjectDataSource的StartRowIndexParameterName和MaximumRowsParameterName(startIndex和maxRows).</p>
<p>　　３.设置 ObjectDataSource的 SelectCountMethod Property 为返回分页记录总数的方法的名字(TotalNumberOfProducts)–调用ProductsBLL类的TotalNumberOfProducts方法返回总的记录数 . ObjectDataSource 需要这个信息来正确的显示页面.</p>
<p>　　４.从ObjectDataSource的声明里移除startRowIndex and maximumRows &lt;asp:Parameter&gt; 元素的标记– 当通过向导配置 ObjectDataSource 时, Visual Studio 自动为GetProductsPaged方法的参数增加了两个&lt;asp:Parameter&gt; 元素. 设置EnablePaging 为true后, 这些参数会被自动传递;如果在声明代码里保留它们,那么ObjectDataSource会试图传递4个参数给GetProductsPaged和2个参数给TotalNumberOfProducts .如果你没有移除&lt;asp:Parameter&gt; ,当浏览页面的时候你会获得一个象这样的错误信息 : “ObjectDataSource 'ObjectDataSource1' could not find a non-generic method 'TotalNumberOfProducts' that has parameters: startRowIndex, maximumRows.”</p>
<p>做完这些改动后,ObjectDataSource的声明代码看起来应该和下面差不多:</p>
<pre>
&lt;asp:ObjectDataSource ID="ObjectDataSource1" runat="server"
 OldValuesParameterFormatString="original_{0}" TypeName="ProductsBLL"
 SelectMethod="GetProductsPaged" EnablePaging="True"
 SelectCountMethod="TotalNumberOfProducts"&gt;
&lt;/asp:ObjectDataSource&gt;</pre>
<p>注意EnablePaging和SelectCountMethod属性已经被设置了,&lt;asp:Parameter&gt;被移除了.图16是属性窗口.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1NjE3MC5wbmc=.jpg"></p>
<p><strong>图16: 使用自定义分页配置,ObjectDataSource</strong></p>
<p>　　完成这些后,浏览页面.你会看到10条product按照字母排序被列出来了.每次翻一页看看.对用户来说现在还看不出来什么差别,因为自定义分页在大数据量的情况下效率才能显示出来.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1NjE3MS5wbmc=.jpg"></p>
<p><strong>图17: 根据Product的 Name排序的数据的自定义分页</strong></p>
<p>　　注意:自定义分页时,ObjectDataSource的SelectCountMethod方法返回的page count值存在GridView的view state里.其它变量–PageIndex,EditIndex,SelectedIndex,DataKeys集合等–都存在control state里.control state和GridView的EnableViewState属性无关.由于PageCount的值在postback期间存在viewstate里,当你的页面上有链到上一页的link时,你需要开启GridView的view state(如果没有这个link,你可以禁用view state).</p>
<p>　　点上一页link会引起postback,GridView会更新PageIndex属性.GridView会给PageIndex赋一个小于PageCount的值.如果禁用了view state,PageCount的值在postback时会丢失,PageIndex会被赋一个最大的整型值.然后GridView在根据PageSize乘PageCount来计算starting row index时会发生OverflowException异常.</p>
<p>执行自定义分页和排序</p>
<p>　　目前我们自定义分页时使用的排序字段是在创建GetProductsPaged存储过程时写死的.在GridView的智能标签里有一个Enable Sorting的checkbox,不幸的是,在前面的工作里加上排序功能仅仅只能将当前页的记录排序.比如,按照降序查看第一页的数据,第一页的product的顺序回反转.见图18,Carnarvon Tigers 成为第一条记录,而在它之后的71条记录被忽略了.排序时只排了显示在第一页的数据.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDUwNzE2MzM1OTE3Mi5wbmc=.jpg"></p>
<p><strong>图18: 只有当前页的数据被排序了</strong></p>
<p>　　发生这种情况的原因是调用完BLL的GetProductsPaged方法返回数据之后才排序.耳针个方法只返回特定页的记录.为了正确的排序,我们需要将排序表达式传到GetProductsPaged方法里,在返回特定页的数据前进行排序.我们将在后面的教程里完成这个功能.</p>
<p>执行自定义分页和删除</p>
<p>　　如果你开启GridView的删除功能,你会发现删除最后一页的最后一条记录时,GridView消失了,而不是正确的减掉PageIndex的值.在我们上面创建的GridView里开启删除来查看这个bug.到最后一页(第九页),由于我们有81条记录,每页显示10条,所以你会只看到一条记录,删除这条记录.</p>
<p>　　在默认分页时,GridView会自动跳到第八页,这也是我们想要的结果.然而在自定义分页里, GridView却显示.发生这个的原因有点超出了本教程的范围,可以看Deleting the Last Record on the Last Page from a GridView with Custom Paging.简单的说是因为点Delete时,GridView是按这样的步骤工作的:   </p>
<p>删除记录.<br />
   </p>
<p>　　按照给定的PageIndex和PageSize获取记录.</p>
<p>　　检查PageIndex确保没有超过数据源的页的数量.如果是,GridView的PageIndex会自动减.</p>
<p>　　使用第二步获取的记录绑定到GridView适当的页.</p>
<p>　　问题的根源在于第二步,当获取显示的记录时,使用的PageIndex仍然是最后一页的PageIndex.因此没有记录被返回.在第三步里GridView判断出PageIndex属性大于数据源的总页数(因为最后一页的最后一条数据被删除了) 就对PageIndex减1.在第四步里GridView试图将第二步获取的数据作为数据源进行绑定,但是没有任何数据,因此显示的GridView不见了.在默认分页里没有这个问题是因为在第二步还是返回的所有数据.</p>
<p>　　我们可以用两种方法来修改这个.第一是为GridView的RowDeleted事件创建一个event handler<br />
来判断在删除页里有多少条记录,如果只有一条,那么这条肯定是最后一条,我们需要为PageIndex减1.当然我们希望只在删除成功后来修改PageIndex的值.我们需要用e.Exception属性是否为空来判断.</p>
<p>　　这个方法之所以起作用是因为它在第一步和第二步之间修改了PageIndex的值.因此在第二步里正确的记录会被返回.见如下代码:</p>
<pre>
protected void GridView1_RowDeleted(object sender, GridViewDeletedEventArgs e)
{
 // If we just deleted the last row in the GridView, decrement the PageIndex
 if (e.Exception == null &amp;&amp; GridView1.Rows.Count == 1)
 // we just deleted the last row
 GridView1.PageIndex = Math.Max(0, GridView1.PageIndex - 1);
}
</pre>
<p>　　另外一种办法是为ObjectDataSource的RowDeleted事件创建一个event handler,设置AffectedRows属性为1.在第一步删除记录后(在第二步之前),如果一行或多行记录被影响,GridView会更新PageIndex的值.然而ObjectDataSource 并没有设置AffectedRows,因此这一步不会执行.我们需要在删除操作成功的情况下手动设置AffectedRows.见下面的代码:</p>
<pre>
protected void ObjectDataSource1_Deleted(
 object sender, ObjectDataSourceStatusEventArgs e)
{
 // If we get back a Boolean value from the DeleteProduct method and it's true,
 // then we successfully deleted the product. Set AffectedRows to 1
 if (e.ReturnValue is bool &amp;&amp; ((bool)e.ReturnValue) == true)
 e.AffectedRows = 1;
}
</pre>
<p>　　这些代码都可以在EfficientPaging.aspx的code-behind class里找到</p>
<p>比较默认和自定义分页的性能</p>
<p>　　由于自定义分页返回需要的数据,而默认分页返回全部数据,因此自定义分页比默认分页更有效率是非常清楚的.但是性能上的提升究竟有多少?从默认分页换成自定义分页有什么性能上的优势?</p>
<p>　　很不幸,没有一个统一的答案.性能的优势取决于很多因素,其中最重要的是分页记录的数量,数据库的负载和web server和数据库的通信渠道.对一些小的表来说,性能的差异是可以忽略的.对成千上万行数据的表来说,差异是非常明显的.</p>
<p>　　我们的一篇Custom Paging in ASP.NET 2.0 with SQL Server 2005文章包含一些对比这两种分页技术的性能测试,用到的表有大概50,000 条记录.在测试中我分别测试了在SQL Server里（使用SQL Profiler）和ASP.NET页面里（使用ASP.NET's tracing features）执行查询的时间．注意这是在我的开发环境下单个用户的测试结果，因此没有模仿典型的网站的负载情况，结果也并不科学．</p>
<table>
<tbody>
<tr>
<td> </td>
<td>Avg. Duration (sec)</td>
<td>Reads</td>
</tr>
<tr>
<td>Default Paging – SQL Profiler</td>
<td>1.411</td>
<td>383</td>
</tr>
<tr>
<td>Custom Paging – SQL Profiler</td>
<td>0.002</td>
<td>29</td>
</tr>
<tr>
<td>Default Paging – ASP.NET Trace</td>
<td>2.379</td>
<td>N/A</td>
</tr>
<tr>
<td>Custom Paging – ASP.NET Trace</td>
<td>0.029</td>
<td>N/A</td>
</tr>
</tbody>
</table>
<p>　　如你所见，获取特定页的数据平均少了354 reads，并在恩短的时间完成．而在页面里，自定义分页是默认分页所花费时间的1/100．在my article 可以看到更多的测试信息和代码，你可以下载测试数据库在你的环境里重新测试．</p>
<p><strong>总结</strong></p>
<p>　　默认分页是非常容易实现的–你仅仅只需要选择控件上的智能标签里的Enable Paging checkbox –但是方便带来的是性能的损失．在默认分页时，用户无论请求哪个页面，所有的数据都会被返回，即使只有一小部分被显示出来．为了提升性能，ObjectDataSource 提供了一个可选择的分页功能–自定义分页．</p>
<p>　　自定义分页通过只获取需要显示的数据来解决默认分页的性能问题，但是使用起来更麻烦．首先，请求特定数据的查询语句必须正确而且有效．这个可以通过很多方法来实现．在本教程里我们使用SQL Server 2005的ROW_NUMBER来实现给结果分级，然后返回等级在特定范围内的数据．其次我们需要增加一个方法来获取需要分页的总记录数．在创建完DAL和BLL方法后，我们还需要配置ObjectDataSource以使它可以获取需要分页的总记录数，并将正确的Row Index 和Maximum Rows 的值传给BLL．</p>
<p>　　虽然使用自定义分页需要一系列的操作，而且远没有默认分页那么简单．但是在大数据量的情况还是必须的．只显示需要的数据，自定义分页可以节省很多时间，减轻数据库的负担．</p>
<p>祝编程快乐！</p>
<p><strong>作者简介</strong></p>
<p>Scott Mitchell，著有六本ASP/ASP.NET方面的书，是4GuysFromRolla.com的创始人，自1998年以来一直应用 微软Web技术。Scott是个独立的技术咨询顾问，培训师，作家，最近完成了将由Sams出版社出版的新作，24小时内精通ASP.NET 2.0。他的联系电邮为mitchell@4guysfromrolla.com，也可以通过他的博客http://scottonwriting.net/与他联系。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索asp.net<br />
                                    分页<br />
                                    ，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 16:43:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/asp-net/" title="asp&period;net">asp&period;net</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e9%a1%b5/" title="分页">分页</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>在ASP.NET 2.0中操作数据之二十五：大数据量时提高分页的效率_自学过程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4w1JYp.html" rel="bookmark">ASP&period;NET 2&period;0数据教程之二十五&colon;大数据量时提高分页的效率</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				返回&quot;ASP.NET 2.0数据教程目录&quot; 如我们在之前的教程里讨论的那样,分页可以通过两种方法来实现: 默 认分页– 你仅仅只用选中data Web control的智能标签的Enable Paging ; 然而,当你浏览页面的时候,虽然你看到的只是一小部分数据,ObjectDataSource 还是会每次都读取所有数据 自定义分页– 通过只从数据库读取用户 需要浏览的那部分数据,提高了性能.显然这种方法需要你做更多的工作. 默认的分页功能非常吸引人,因为你只需要选中一个checkb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4Ng3jM.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之十七：研究插入、更新和删除的关联事件&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 当使用GridView.DetailsView或FormView控件的内建插入.编辑或删除特征时,在用户添加一条新记录或更新/删除一条现在记录的过程中发生了多个步骤.正如我们之前一节里所讨论的,在GridView中编辑一行时,保存(Update)和取消(Cancel)按钮将取代编辑(Edit)按钮,并且绑定列转换成TextBox.在用户更新了数据并点击保存按钮之后,下述步骤在回传时执行: 1.该GridView控件根据当前编辑行的唯一标识字段(通过DataKeyNames属性)组装它的Ob			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZw3Kb.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二十：定制数据修改界面&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 GridView和DetailsView控件通过绑定列和CheckBox列,可以简化数据编辑界面制作,呈现只读,编辑和新增界面,我们不需要增加元素标记或编写任何额外代码就可以得到这些界面.然而,绑定列和CheckBox列呈现的界面却缺乏实际应用中经常用到的定制功能.为了对GridView和DetailsView的编辑.新增界面进行定制,需要用模板列(TemplateField)替换原有列. 在上节教程中我们讨论如何增加验证控件来定制数据编辑界面,而本节教程将演示如何使用Web控件对实际的数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJOo62b.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二十四：分页和排序报表数据&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 分页和排序是在WEB应用程序中展现数据常见的功能.比如,当我们在一个网上书店搜索ASP.NET书籍的时候,可能有几百本相关书籍,但是我们只希望每页显示10条有效记录.而且,我们还希望结果能根据标题.价格.页数和作者等等来进行排序.过去的23个教程中我们研究了如何建立各种报表,包括在界面上添加编辑和删除数据.但是我们没有研究如何对数据进行排序,对于分页我们也仅在研究DetailsView和FormView控件的时候看到. Step 1:添加分页和排序页面 在我们开始以前,首先让我们花些时间来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYA5Zb.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二十九：用DataList和Repeater来显示数据&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 在之前的28篇教程的例子里,如果我们需要显示某个数据源的多条记录,我们使用GridView .GridView 的一行表示数据源的一条记录,列表示一个字段.虽然GridView 用来显示数据,分页,排序,编辑,删除非常的方便,但是有点臃肿.而且GridView 结构的标记是固定的-它包含一个带有&lt;tr&gt;和&lt;td&gt;的HTML &lt;table&gt;标记. 为了在显示多条记录时,有更好的自定义功能,ASP.NET 2.0提供了DataList 和Repeater (ASP.N			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVXyOQM.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二十二：为删除数据添加客户端确认&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 在前面一些教程中,我们已经看到如何使用应用程序框架,ObjectDataSource,以及那些提供增.改.删功能的数据Web控件.在我们已经实现的删除数据的界面中,包含一个删除按钮,当点击它的时候,会导致数据回传以及调用ObjectDataSource的Delete()方法.然后Delete()方法会调用对应业务逻辑层中的方法,再进入数据访问层,直至调用最终操作数据库的DELETE语句. 虽然这个界面已经能够让用户通过GridView,DetailsView,或者FormView控件来删除			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXNe8Kb.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二十六：排序自定义分页数据&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 和默认翻页方式相比,自定义分页能提高几个数量级的效率.当我们的需要对大量数据分页的时候就需要考虑自定义分页,然而实现自定义分页相比默认分页需要做更多工作.对于排序自定义分页数据也是这样,在本教程中我们就会扩展前面的例子来实现自定义分页数据的排序. 注意:既然本教程是基于前一个的,因此我们需要把前面教程示例页面EfficientPaging.aspx的&lt;asp:Content&gt;元素中的代码复制到本教程SortParameter.aspx示例页面中.关于如何进行这样的复制操作请参看为删除数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLYvyAz.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二十八：GridView里的Button&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 一般控件(比如GridView)显示数据的时候对数据只能读取,而需要处理数据的功能是非常常见的.典型的情况是为每行数据添加一个Button, LinkButton, 或ImageButton . 当点击这些button时,数据会PostBack,执行一些服务器端的代码. 一条条的编辑或删除数据是最常见的情况.实际上,编辑和删除是如此常见,从概述插入.更新和删除数据 开始, 我们可以看到GridView, DetailsView, 和 FormView可以零代码的完成这些功能. 除了编辑和删			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Ng0Vb.html" rel="bookmark">在ASP&period;NET 2&period;0中操作数据之二：创建一个业务逻辑层&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导言 本教程的第一节所描述的数据访问层(Data Access Layer,以下简称为DAL)已经清晰地将表示逻辑与数据访问逻辑区分开了.不过,即使DAL将数据访问的细节从表示层中分离出来了,可它却不能处理任何的业务规则.比如说,我们可能不希望产品表中那些被标记为&quot;停用&quot;的产品的&quot;分类编号&quot;或&quot;供应商编号&quot;被更新:我们还可能需要应用一些资历规则,比如说我们都不希望被比自己的资历还要浅的人管理.另外一个比较常见的情况就是授权,比如说只有那些具有特殊			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/75zO5MG.html" rel="bookmark" class="title">解决win7系统唤醒休眠状态出现&OpenCurlyDoubleQuote;拒绝访问&rdquo;错误的方法</a>
					<div>
						  windows休眠状态是指将所有运行的实时数据存储到硬盘上,并且关闭一切不必要的硬件从而节省电量,无论你所使用的windows是哪个版本,系统都能够让用户自动进入休眠状态,当然在你没有关闭休眠功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAQBQM.html" rel="bookmark" class="title">调优servlet和JSP的程序性能</a>
					<div>
						本文讲述了调整JSP和servlet的一些非常实用的方法,它可使你的servlet和JSP页面响应更快,扩展性更强.而且在用户数增加的情况下,系统负载会呈现出平滑上长的趋势.在本文中,我将通过一些实际 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6k9op.html" rel="bookmark" class="title">javascript键盘事件&colon;javascript键盘事件的＂Enter＂</a>
					<div>
						&lt;script type=&quot;text/javascript&quot;&gt;function send(event){//如果按了回车键也发送信息if(event.keyCode== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnELZM.html" rel="bookmark" class="title">session设置说明</a>
					<div>
						session [Session]session.save_handler      = files   ; 用于保存/取回数据的控制方式session.save_path         = C:\ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEmA9b.html" rel="bookmark" class="title">ASP无限级分类</a>
					<div>
						  比较简单的一个页面,类似csdn论坛在ns下的左边列表   描述:   1.   数据名:tree.mdb   表名:tree   表结构:id(自编) pid(数字) content(文本) l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxxNWb.html" rel="bookmark" class="title">WPF and Silverlight学习笔记（七）</a>
					<div>
						WPF and Silverlight学习笔记(七):WPF布局管理之StackPanel.WrapPanel.DockPanel 一.StackPanel StackPanel是以堆叠的方式显示其中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKYWNp.html" rel="bookmark" class="title">OData、实体框架和 Windows Azure 访问控制</a>
					<div>
						在本文中,我将阐述使用实体框架(通过 Windows Communication Foundation (WCF) RESTful 服务公开 并用 Windows Azure 访问控制服务 (ACS) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNmn8b.html" rel="bookmark" class="title">通过P&sol;Invoke返回Struct和String Array</a>
					<div>
						P/Invoke提供了方便的.NET和c++ dll交互接口,通过P/Invoke可以将native的对象转化成managed object,从而享受.NET带来的种种便利. 但是,假如dll中返回的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZEZqz.html" rel="bookmark" class="title">ae模板素材丢失现彩条的解决办法</a>
					<div>
						ae模板素材丢失现彩条的解决办法   1.出现这种情况,先查看一下AE CC 2015的编辑界面,如果显示有这样的状态,那么说明是素材没有完整被AE导入. 2.如图中所示,此时我们可以列表中[ 双击一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywLBPz.html" rel="bookmark" class="title">asp下检查表中是否存在某个字段（列）函数&lowbar;应用技巧</a>
					<div>
						复制代码 代码如下: Function   CheckFields(FieldsName,TableName)       Flag=False       sql=&quot;select   *  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwG97p.html" rel="bookmark" class="title">滚动条-highstock&period;js 条形图 纵向滚动</a>
					<div>
						问题描述 highstock.js 条形图 纵向滚动 条形图:如果数据比较多时,一页显示不完全,下部的数据展示区提供上下滚动条(右侧),但上方的标题不动. 解决方案 图标外面套两个div,父div完全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NAgNM.html" rel="bookmark" class="title">百度地图之收索视野内的建筑物</a>
					<div>
						根据用户移动地图的位置,显示在视野范围内的建筑物,简单的思路是,添加地图监听,当地图移动结束之后,计算出当前屏幕四个角的GeoPoint,根据这4个点,通过mysql的spatial中的函数,完成在此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6JVwz.html" rel="bookmark" class="title">JUnit中对Exception的判断</a>
					<div>
						说来惭愧,虽然之前已经看过JUnit的源码了,也写了几篇博客,但是长时间不写Test Case,今天想要写抛Exception相关的test case时,竟然不知道怎么写了.....好记性不如烂笔头, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAGrDp.html" rel="bookmark" class="title">用Foxmail地址簿实现端与端同步</a>
					<div>
						使用Foxmail地址簿的同步功能,可以实现客户端与服务器端地址簿数据的同步,保持双方数据一致.联系地址保存在网络的服务器上,用户随时随地都可以通过网络, 获取最 新的地址簿信息. 地址簿同步的服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZVoYM.html" rel="bookmark" class="title">webview如何适配h5网页高度</a>
					<div>
						问题描述 webview如何适配h5网页高度 现在首页的部分区域使用webview加载h5界面 webview的高度固定 但是如何保证加载 的h5界面 完全在webview中显示 而不是下拉webvi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZLKqz.html" rel="bookmark" class="title">json-Json传送数据的问题 Sturct2</a>
					<div>
						问题描述 Json传送数据的问题 Sturct2 在做web作业的时候想用json传送数据 server端用的是Java SSH框架, 按照网上的方法使用了eclipse报了这个错: 严重: Serv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRnXOb.html" rel="bookmark" class="title">饿了么：日订单量超900万的架构设计及演进之路</a>
					<div>
						网站在刚开始的时候大概只是一个想法:一个产业的模型,快速地将它产生出来.&quot;快&quot;是第一位的,不需要花太多精力在架构设计上.在网站进入扩张期才需要对架构投入更多的精力来承载网站在爆发时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZDkRz.html" rel="bookmark" class="title">EasyUI----DataGrid 导出 Excel</a>
					<div>
						最近做的安防项目有个功能,需要把DataGrid中的数据导出,下面通过代码一步一步的介绍; 首先在js中写一个扩展类,主要的功能是把DataGrid中的数据转换成Excel的XML格式 '''将dat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmPZkM.html" rel="bookmark" class="title">终于找到一个比较好的web打印方案了</a>
					<div>
						问题描述 前段时间一直在研究web打印,刚开始使用js的WebBrowser控件来实现,花了2天时间,研究的差不多了,回来发现打印的时候总是会提示选择打印机的框,查询N次百度和google,最终木有找 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR6Kjp.html" rel="bookmark" class="title">sharepoint的列表超出阀值</a>
					<div>
						问题描述 我的列表项数量超出5000了,不能排序和筛选,要怎样弄呢,要写代码吗, 解决方案 解决方案二:分文件夹层次存储到管理中心改阈值解决方案三:不用写代码,视图默认限制的项目数是5000,为了更好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWoKeM.html" rel="bookmark" class="title">Windows下的tail一二三：tail、BareTail、WinTail</a>
					<div>
						Windows下的tail一二三:tail.BareTail.WinTail 在Windows下查看输了的日志log的文件,使用UE或Edit plus可以知道文件改变了,但是光标都会回到文件头部去, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJoo3p.html" rel="bookmark" class="title">打不开-下载完ivsm-4500v1&period;5&period;ipa后，不知如何打开？</a>
					<div>
						问题描述 下载完ivsm-4500v1.5.ipa后,不知如何打开? 下载完ivsm-4500v1.5.ipa后,不知如何打开?用什么打开? 解决方案 itunes安装应用程序和ipa文件的安装 ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq76x3z.html" rel="bookmark" class="title">ebs系统架构简介7&period;1&mdash;&mdash;rac clone</a>
					<div>
						今天在rac环境clone 的时候,查看日志: /testebs/uat/db/11.2.0/appsutil/log/TESTUAT1_hostname1/ApplyDatabase_1220120 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0Jq0M.html" rel="bookmark" class="title">Google在铺成其光纤宽带网络的同时也在积极准备进入虚拟运营商市场</a>
					<div>
						Google在铺成其光纤宽带网络的同时也在积极准备进入虚拟运营商市场.据称,自2013年初以来,Google已经和Sprint及Verizon接触,表达过此意向并探讨了可能性.不过从目前没有任何消息的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN5qlp.html" rel="bookmark" class="title">php SimpleXML读写XML接口文件例子分析</a>
					<div>
						创建一个SimpleXML对象有三种方法: 使用new关键字创建  代码如下 复制代码 $xml=&quot;&lt;personinfo&gt;&lt;item&gt;&lt;id&gt;1&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLg8vM.html" rel="bookmark" class="title">Mysql Limit 分页查询优化详解&lowbar;Mysql</a>
					<div>
						select * from table LIMIT 5,10; #返回第6-15行数据 select * from table LIMIT 5; #返回前5行 select * from table  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwK18mz.html" rel="bookmark" class="title">Codeigniter框架前后台部署&lpar;多目录部署&rpar;</a>
					<div>
						个网站一般包含前台和后台并且访问的url是不同的,Codeigniter怎么来部署呢? 在网上看到了一篇比较好的文章: 在下载好的ci的根目录建立一个目录 admin 将application目录中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8JKAb.html" rel="bookmark" class="title">不同的领域，同样的声音&lpar;转&rpar;</a>
					<div>
						  &quot;不管是黑幕还是真实投票,梁博大概都会拿冠军,因为--昨晚看过美国好声音的一些视频后,回想起中国好声音,由&quot;好声音&quot;做一个引子,写了不少别的感想(设计,游戏),随便看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q1gAp.html" rel="bookmark" class="title">《C&num;并发编程经典实例》&mdash;&mdash; 超时</a>
					<div>
						声明:本文是&lt;C#并发编程经典实例&gt;的样章,感谢图灵授权并发编程网站发布样章,禁止以任何形式转载此文. 问题 我们希望事件能在预定的时间内到达,即使事件不到达,也要确保程序能及时进行响应. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgO52z.html" rel="bookmark" class="title">蓝牙4&period;0将于今年第四季度面世</a>
					<div>
						3月5日消息,据蓝牙技术联盟(Bluetooth Special Interest Group)称,蓝牙4.0规范将于今年第四季度出现在耳机.智能手机和PC中. 据国外媒体报道称,蓝牙技术联盟执行主任 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.051 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
